diff --git a/src/dosext/mfs/lfn.c b/src/dosext/mfs/lfn.c
index 70c7081b6d..52a3044bf0 100644
--- a/src/dosext/mfs/lfn.c
+++ b/src/dosext/mfs/lfn.c
@@ -104,11 +104,15 @@ static char *handle_to_filename(int handle, int *fd)
 	if ( (sp & 0xFFFF) == 0xffff )
 		return NULL;
 
-	/* do we "own" the drive? */
-	*fd = 0;
 	dd = sft_device_info(sft) & 0x0d1f;
-	if (dd < 0 || dd >= MAX_DRIVE || !drives[dd].root)
+	if (dd < 0 || dd >= MAX_DRIVE)
+		return NULL;
+	/* do we "own" the drive? */
+	if (!drives[dd].root) {
+		d_printf("LFN: not owning drive %i (fd %i)\n", dd, handle);
+		*fd = 0;
 		return NULL;
+	}
 
 	return sft_to_filename(sft, fd);
 }
diff --git a/src/dosext/mfs/mfs.c b/src/dosext/mfs/mfs.c
index 2c0cb3f6bf..10bb6dca6d 100644
--- a/src/dosext/mfs/mfs.c
+++ b/src/dosext/mfs/mfs.c
@@ -3116,8 +3116,11 @@ void get_volume_label(char *fname, char *fext, char *lfn, int drive)
 char *sft_to_filename(unsigned char *sft, int *fd)
 {
   int cnt = sft_fd(sft);
-  *fd = open_files[cnt].name ? open_files[cnt].fd : 0;
-  return open_files[cnt].name;
+  if (open_files[cnt].name) {
+    *fd = open_files[cnt].fd;
+    return open_files[cnt].name;
+  }
+  return NULL;
 }
 
 int dos_rmdir(const char *filename1, int drive, int lfn)
